---
title: Using Promises
slug: Web/JavaScript/Guide/Using_promises
tags:
  - Guide
  - Intermediate
  - JavaScript
  - Promise
  - Promises
  - asynchronous
  - 'l10n:priority'
---
<div>{{jsSidebar("JavaScript Guide")}}{{PreviousNext("Web/JavaScript/Guide/Details_of_the_Object_Model", "Web/JavaScript/Guide/Iterators_and_Generators")}}</div>

<p class="summary"><span class="seoSummary">A {{jsxref("Promise")}} is an object representing the eventual completion or failure of an asynchronous operation. Since most people are consumers of already-created promises, this guide will explain consumption of returned promises before explaining how to create them.</span></p>

<p>Essentially, a promise is a returned object to which you attach callbacks, instead of passing callbacks into a function.</p>

<p>Imagine a function, <code>createAudioFileAsync()</code>, which asynchronously generates a sound file given a configuration record and two callback functions, one called if the audio file is successfully created, and the other called if an error occurs.</p>

<p>Here's some code that uses <code>createAudioFileAsync()</code>:</p>

<pre class="brush: js line-numbers  language-js notranslate">function successCallback(result) {
  console.log("Audio file ready at URL: " + result);
}

function failureCallback(error) {
  console.error("Error generating audio file: " + error);
}

createAudioFileAsync(audioSettings, successCallback, failureCallback);
</pre>

<p>Modern functions return a promise that you can attach your callbacks to instead:</p>

<p>If <code>createAudioFileAsync()</code> were rewritten to return a promise, using it could be as simple as this:</p>

<pre class="brush: js notranslate">createAudioFileAsync(audioSettings).then(successCallback, failureCallback);</pre>

<p>That's shorthand for:</p>

<pre class="brush: js line-numbers  language-js notranslate">const promise = createAudioFileAsync(audioSettings);
promise.then(successCallback, failureCallback);</pre>

<p>We call this an <em>asynchronous function call</em>. This convention has several advantages. We will explore each one.</p>

<h2 id="Guarantees">Guarantees</h2>

<p>Unlike old-fashioned <em>passed-in</em> callbacks, a promise comes with some guarantees:</p>

<ul>
 <li>Callbacks will never be called before the <a href="/en-US/docs/Web/JavaScript/EventLoop#Run-to-completion">completion of the current run</a> of the JavaScript event loop.</li>
 <li>Callbacks added with <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/then">then()</a></code>, as above, will be called even <em>after</em> the success or failure of the asynchronous operation.</li>
 <li>Multiple callbacks may be added by calling <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/then">then()</a></code> several times. Each callback is executed one after another, in the order in which they were inserted.</li>
</ul>

<p>One of the great things about using promises is <strong>chaining</strong>.</p>

<h2 id="Chaining">Chaining</h2>

<p>A common need is to execute two or more asynchronous operations back to back, where each subsequent operation starts when the previous operation succeeds, with the result from the previous step. We accomplish this by creating a <strong>promise chain</strong>.</p>

<p>Here's the magic: the <code>then()</code> function returns a <strong>new promise</strong>, different from the original:</p>

<pre class="brush: js notranslate">const promise = doSomething();
const promise2 = promise.then(successCallback, failureCallback);
</pre>

<p>or</p>

<pre class="brush: js notranslate">const promise2 = doSomething().then(successCallback, failureCallback);
</pre>

<p>This second promise (<code>promise2</code>) represents the completion not just of <code>doSomething()</code>, but also of the <code>successCallback</code> or <code>failureCallback</code> you passed in, which can be other asynchronous functions returning a promise. When that's the case, any callbacks added to <code>promise2</code> get queued behind the promise returned by either <code>successCallback</code> or <code>failureCallback</code>.</p>

<p>Basically, each promise represents the completion of another asynchronous step in the chain.</p>

<p>In the old days, doing several asynchronous operations in a row would lead to the classic callback pyramid of doom:</p>

<pre class="brush: js notranslate">doSomething(function(result) {
  doSomethingElse(result, function(newResult) {
    doThirdThing(newResult, function(finalResult) {
      console.log('Got the final result: ' + finalResult);
    }, failureCallback);
  }, failureCallback);
}, failureCallback);
</pre>

<p>With modern functions, we attach our callbacks to the returned promises instead, forming a promise chain:</p>

<pre class="brush: js notranslate">doSomething()
.then(function(result) {
  return doSomethingElse(result);
})
.then(function(newResult) {
  return doThirdThing(newResult);
})
.then(function(finalResult) {
  console.log('Got the final result: ' + finalResult);
})
.catch(failureCallback);
</pre>

<p>The arguments to <code>then</code> are optional, and <code>catch(failureCallback)</code> is short for <code>then(null, failureCallback)</code>. You might see this expressed with <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">arrow functions</a> instead:</p>

<pre class="brush: js notranslate">doSomething()
.then(result =&gt; doSomethingElse(result))
.then(newResult =&gt; doThirdThing(newResult))
.then(finalResult =&gt; {
  console.log(`Got the final result: ${finalResult}`);
})
.catch(failureCallback);
</pre>

<p><strong>Important:</strong> Always return results, otherwise callbacks won't catch the result of a previous promise (with arrow functions <code>() =&gt; x</code> is short for <code>() =&gt; { return x; }</code>).</p>

<h3 id="Chaining_after_a_catch">Chaining after a catch</h3>

<p>It's possible to chain <em>after</em> a failure, i.e. a <code>catch</code>, which is useful to accomplish new actions even after an action failed in the chain. Read the following example:</p>

<pre class="brush: js notranslate">new Promise((resolve, reject) =&gt; {
    console.log('Initial');

    resolve();
})
.then(() =&gt; {
    throw new Error('Something failed');

    console.log('Do this');
})
.catch(() =&gt; {
    console.error('Do that');
})
.then(() =&gt; {
    console.log('Do this, no matter what happened before');
});
</pre>

<p>This will output the following text:</p>

<pre class="notranslate">Initial
Do that
Do this, no matter what happened before
</pre>

<p><strong>Note:</strong> The text <q>Do this</q> is not displayed because the <q>Something failed</q> error caused a rejection.</p>

<h2 id="Error_propagation">Error propagation</h2>

<p>You might recall seeing <code>failureCallback</code> three times in the pyramid of doom earlier, compared to only once at the end of the promise chain:</p>

<pre class="brush: js notranslate">doSomething()
.then(result =&gt; doSomethingElse(result))
.then(newResult =&gt; doThirdThing(newResult))
.then(finalResult =&gt; console.log(`Got the final result: ${finalResult}`))
.catch(failureCallback);
</pre>

<p>If there's an exception, the browser will look down the chain for <code>.catch()</code> handlers or <code>onRejected</code>. This is very much modeled after how synchronous code works:</p>

<pre class="brush: js notranslate">try {
  const result = syncDoSomething();
  const newResult = syncDoSomethingElse(result);
  const finalResult = syncDoThirdThing(newResult);
  console.log(`Got the final result: ${finalResult}`);
} catch(error) {
  failureCallback(error);
}
</pre>

<p>This symmetry with asynchronous code culminates in the <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function"><code>async</code>/<code>await</code></a> syntactic sugar in ECMAScript 2017:</p>

<pre class="brush: js notranslate">async function foo() {
  try {
    const result = await doSomething();
    const newResult = await doSomethingElse(result);
    const finalResult = await doThirdThing(newResult);
    console.log(`Got the final result: ${finalResult}`);
  } catch(error) {
    failureCallback(error);
  }
}
</pre>

<p>It builds on promises, e.g. <code>doSomething()</code> is the same function as before. You can read more about the syntax <a href="https://developers.google.com/web/fundamentals/getting-started/primers/async-functions">here</a>.</p>

<p>Promises solve a fundamental flaw with the callback pyramid of doom, by catching all errors, even thrown exceptions and programming errors. This is essential for functional composition of asynchronous operations.</p>

<h2 id="Promise_rejection_events">Promise rejection events</h2>

<p>Whenever a promise is rejected, one of two events is sent to the global scope (generally, this is either the <a href="/en-US/docs/Web/API/Window" title="The Window interface represents a window containing a DOM document; the document property points to the DOM document loaded in that window."><code>window</code></a> or, if being used in a web worker, it's the <a href="/en-US/docs/Web/API/Worker" title="The Worker interface of the Web Workers API represents a background task that can be created via script, which can send messages back to its creator."><code>Worker</code></a> or other worker-based interface). The two events are:</p>

<dl>
 <dt><a href="/en-US/docs/Web/API/Window/rejectionhandled_event" title="The rejectionhandled event is sent to the script's global scope (usually window but also Worker) whenever a JavaScript Promise is rejected but after the promise rejection has been handled."><code>rejectionhandled</code></a></dt>
 <dd>Sent when a promise is rejected, after that rejection has been handled by the executor's <code>reject</code> function.</dd>
 <dt><a href="/en-US/docs/Web/API/Window/unhandledrejection_event" title="The unhandledrejection event is sent to the global scope of a script when a JavaScript Promise that has no rejection handler is rejected; typically, this is the window, but may also be a Worker."><code>unhandledrejection</code></a></dt>
 <dd>Sent when a promise is rejected but there is no rejection handler available.</dd>
</dl>

<p>In both cases, the event (of type <a href="/en-US/docs/Web/API/PromiseRejectionEvent" title="The PromiseRejectionEvent interface represents events which are sent to the global script context when JavaScript Promises are rejected."><code>PromiseRejectionEvent</code></a>) has as members a <a href="/en-US/docs/Web/API/PromiseRejectionEvent/promise" title="The PromiseRejectionEvent interface's promise read-only property indicates the JavaScript Promise which was rejected. You can examine the event's PromiseRejectionEvent.reason property to learn why the promise was rejected."><code>promise</code></a> property indicating the promise that was rejected, and a <a href="/en-US/docs/Web/API/PromiseRejectionEvent/reason" title="The read-only PromiseRejection property reason read-only property is any JavaScript value or Object which provides the reason passed into Promise.reject(). This in theory provides information about why the promise was rejected."><code>reason</code></a> property that provides the reason given for the promise to be rejected.</p>

<p>These make it possible to offer fallback error handling for promises, as well as to help debug issues with your promise management. These handlers are global per context, so all errors will go to the same event handlers, regardless of source.</p>

<p>One case of special usefulness: when writing code for <a href="/en-US/docs/Glossary/Node.js">Node.js</a>, it's common that modules you include in your project may have unhandled rejected promises. These get logged to the console by the Node runtime. You can capture these for analysis and handling by your code—or just to avoid having them cluttering up your output—by adding a handler for the <a href="/en-US/docs/Web/API/Window/unhandledrejection_event" title="The unhandledrejection event is sent to the global scope of a script when a JavaScript Promise that has no rejection handler is rejected; typically, this is the window, but may also be a Worker."><code>unhandledrejection</code></a> event, like this:</p>

<pre class="brush: js notranslate">window.addEventListener("unhandledrejection", event =&gt; {
  /* You might start here by adding code to examine the
     promise specified by event.promise and the reason in
     event.reason */

  event.preventDefault();
}, false);
</pre>

<p>By calling the event's <a href="/en-US/docs/Web/API/Event/preventDefault" title="The Event interface's preventDefault() method tells the user agent that if the event does not get explicitly handled, its default action should not be taken as it normally would be."><code>preventDefault()</code></a> method, you tell the JavaScript runtime not to do its default action when rejected promises go unhandled. That default action usually involves logging the error to console, and this is indeed the case for Node.</p>

<p>Ideally, of course, you should examine the rejected promises to make sure none of them are actual code bugs before just discarding these events.</p>

<h2 id="Creating_a_Promise_around_an_old_callback_API">Creating a Promise around an old callback API</h2>

<p>A {{jsxref("Promise")}} can be created from scratch using its constructor. This should be needed only to wrap old APIs.</p>

<p>In an ideal world, all asynchronous functions would already return promises. Unfortunately, some APIs still expect success and/or failure callbacks to be passed in the old way. The most obvious example is the <a href="/en-US/docs/Web/API/WindowTimers/setTimeout" title="The documentation about this has not yet been written; please consider contributing!"><code>setTimeout()</code></a> function:</p>

<pre class="brush: js notranslate">setTimeout(() =&gt; saySomething("10 seconds passed"), 10*1000);
</pre>

<p>Mixing old-style callbacks and promises is problematic. If <code>saySomething()</code> fails or contains a programming error, nothing catches it. <code>setTimeout</code> is to blame for this.</p>

<p>Luckily we can wrap <code>setTimeout</code> in a promise. Best practice is to wrap problematic functions at the lowest possible level, and then never call them directly again:</p>

<pre class="brush: js notranslate">const wait = ms =&gt; new Promise(resolve =&gt; setTimeout(resolve, ms));

wait(10*1000).then(() =&gt; saySomething("10 seconds")).catch(failureCallback);
</pre>

<p>Basically, the promise constructor takes an executor function that lets us resolve or reject a promise manually. Since <code>setTimeout()</code> doesn't really fail, we left out reject in this case.</p>

<h2 id="Composition">Composition</h2>

<p>{{jsxref("Promise.resolve()")}} and {{jsxref("Promise.reject()")}} are shortcuts to manually create an already resolved or rejected promise respectively. This can be useful at times.</p>

<p>{{jsxref("Promise.all()")}} and {{jsxref("Promise.race()")}} are two composition tools for running asynchronous operations in parallel.</p>

<p>We can start operations in parallel and wait for them all to finish like this:</p>

<pre class="brush: js notranslate">Promise.all([func1(), func2(), func3()])
.then(([result1, result2, result3]) =&gt; { /* use result1, result2 and result3 */ });
</pre>

<p>Sequential composition is possible using some clever JavaScript:</p>

<pre class="brush: js notranslate">[func1, func2, func3].reduce((p, f) =&gt; p.then(f), Promise.resolve())
.then(result3 =&gt; { /* use result3 */ });
</pre>

<p>Basically, we reduce an array of asynchronous functions down to a promise chain equivalent to: <code>Promise.resolve().then(func1).then(func2).then(func3);</code></p>

<p>This can be made into a reusable compose function, which is common in functional programming:</p>

<pre class="brush: js notranslate">const applyAsync = (acc,val) =&gt; acc.then(val);
const composeAsync = (...funcs) =&gt; x =&gt; funcs.reduce(applyAsync, Promise.resolve(x));</pre>

<p>The <code>composeAsync()</code> function will accept any number of functions as arguments, and will return a new function that accepts an initial value to be passed through the composition pipeline:</p>

<pre class="brush: js notranslate">const transformData = composeAsync(func1, func2, func3);
const result3 = transformData(data);
</pre>

<p>In ECMAScript 2017, sequential composition can be done more with async/await:</p>

<pre class="brush: js notranslate">let result;
for (const f of [func1, func2, func3]) {
  result = await f(result);
}
/* use last result (i.e. result3) */
</pre>

<h2 id="Timing">Timing</h2>

<p>To avoid surprises, functions passed to <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/then">then()</a></code> will never be called synchronously, even with an already-resolved promise:</p>

<pre class="brush: js notranslate">Promise.resolve().then(() =&gt; console.log(2));
console.log(1); // 1, 2
</pre>

<p>Instead of running immediately, the passed-in function is put on a microtask queue, which means it runs later when the queue is emptied at the end of the current run of the JavaScript event loop, i.e. pretty soon:</p>

<pre class="brush: js notranslate">const wait = ms =&gt; new Promise(resolve =&gt; setTimeout(resolve, ms));

wait().then(() =&gt; console.log(4));
Promise.resolve().then(() =&gt; console.log(2)).then(() =&gt; console.log(3));
console.log(1); // 1, 2, 3, 4
</pre>

<h4 id="Task_queues_vs_microtasks">Task queues vs microtasks</h4>

<p>Promise callbacks are handled as a <a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide">Microtask</a> whereas <code><a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/setTimeout">setTimeout()</a></code> callbacks are handled as Task queues.</p>

<pre class="brush: js notranslate">const promise = new Promise(function(resolve, reject) {
  console.log("Promise callback");
  resolve();
}).then(function(result) {
  console.log("Promise callback (.then)");
});

setTimeout(function() {
  console.log("event-loop cycle: Promise (fullfilled)", promise)
}, 0);

console.log("Promise (pending)", promise);
</pre>

<p>The code above will output:</p>

<pre class="notranslate">Promise callback
Promise (pending) Promise {&lt;pending&gt;}
Promise callback (.then)
event-loop cycle: Promise (fullfilled) Promise {&lt;fulfilled&gt;}</pre>

<p>For more details, refer to <a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide/In_depth#Tasks_vs_microtasks">Tasks vs microtasks</a>.</p>

<h2 id="Nesting">Nesting</h2>

<p>Simple promise chains are best kept flat without nesting, as nesting can be a result of careless composition. See <a href="#Common_mistakes">common mistakes</a>.</p>

<p>Nesting is a control structure to limit the scope of <code>catch</code> statements. Specifically, a nested <code>catch</code> only catches failures in its scope and below, not errors higher up in the chain outside the nested scope. When used correctly, this gives greater precision in error recovery:</p>

<pre class="brush: js notranslate">doSomethingCritical()
.then(result =&gt; doSomethingOptional(result)
  .then(optionalResult =&gt; doSomethingExtraNice(optionalResult))
  .catch(e =&gt; {})) // Ignore if optional stuff fails; proceed.
.then(() =&gt; moreCriticalStuff())
.catch(e =&gt; console.error("Critical failure: " + e.message));
</pre>

<p>Note that the optional steps here are nested, not from the indentation, but from the precarious placement of the outer <code>(</code> and <code>)</code> around them.</p>

<p>The inner neutralizing <code>catch</code> statement only catches failures from <code>doSomethingOptional()</code> and <code>doSomethingExtraNice()</code>, after which the code resumes with <code>moreCriticalStuff()</code>. Importantly, if <code>doSomethingCritical()</code> fails, its error is caught by the final (outer) <code>catch</code> only.</p>

<h2 id="Common_mistakes">Common mistakes</h2>

<p>Here are some common mistakes to watch out for when composing promise chains. Several of these mistakes manifest in the following example:</p>

<pre class="brush: js example-bad notranslate">// Bad example! Spot 3 mistakes!

doSomething().then(function(result) {
  doSomethingElse(result) // Forgot to return promise from inner chain + unnecessary nesting
  .then(newResult =&gt; doThirdThing(newResult));
}).then(() =&gt; doFourthThing());
// Forgot to terminate chain with a catch!
</pre>

<p>The first mistake is to not chain things together properly. This happens when we create a new promise but forget to return it. As a consequence, the chain is broken, or rather, we have two independent chains racing. This means <code>doFourthThing()</code> won't wait for   <code>doSomethingElse()</code> or <code>doThirdThing()</code> to finish, and will run in parallel with them, likely unintended. Separate chains also have separate error handling, leading to uncaught errors.</p>

<p>The second mistake is to nest unnecessarily, enabling the first mistake. Nesting also limits the scope of inner error handlers, which—if unintended—can lead to uncaught errors. A variant of this is the <a href="https://stackoverflow.com/questions/23803743/what-is-the-explicit-promise-construction-antipattern-and-how-do-i-avoid-it">promise constructor anti-pattern</a>, which combines nesting with redundant use of the promise constructor to wrap code that already uses promises.</p>

<p>The third mistake is forgetting to terminate chains with <code>catch</code>. Unterminated promise chains lead to uncaught promise rejections in most browsers.</p>

<p>A good rule-of-thumb is to always either return or terminate promise chains, and as soon as you get a new promise, return it immediately, to flatten things:</p>

<pre class="brush: js example-good notranslate">doSomething()
.then(function(result) {
  return doSomethingElse(result);
})
.then(newResult =&gt; doThirdThing(newResult))
.then(() =&gt; doFourthThing())
.catch(error =&gt; console.error(error));
</pre>

<p>Note that <code>() =&gt; x</code> is short for <code>() =&gt; { return x; }</code>.</p>

<p>Now we have a single deterministic chain with proper error handling.</p>

<p>Using <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function"><code>async</code>/<code>await</code></a> addresses most, if not all of these problems—the tradeoff being that the most common mistake with that syntax is forgetting the <a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function"><code>await</code></a> keyword.</p>

<h2 id="When_promises_and_tasks_collide">When promises and tasks collide</h2>

<p>If you run into situations in which you have promises and tasks (such as events or callbacks) which are firing in unpredictable orders, it's possible you may benefit from using a microtask to check status or balance out your promises when promises are created conditionally.</p>

<p>If you think microtasks may help solve this problem, see the <a href="/en-US/docs/Web/API/HTML_DOM_API/Microtask_guide">microtask guide</a> to learn more about how to use <a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/queueMicrotask" title="The queueMicrotask() method, which is exposed on the Window or Worker interface, queues a microtask to be executed at a safe time prior to control returning to the browser's event loop."><code>queueMicrotask()</code></a> to enqueue a function as a microtask.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Promise.then()")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function"><code>async</code>/<code>await</code></a> </li>
 <li><a href="http://promisesaplus.com/">Promises/A+ specification</a></li>
 <li><a href="https://medium.com/@ramsunvtech/promises-of-promise-part-1-53f769245a53">Venkatraman.R - JS Promise (Part 1, Basics)</a></li>
 <li><a href="https://medium.com/@ramsunvtech/js-promise-part-2-q-js-when-js-and-rsvp-js-af596232525c#.dzlqh6ski">Venkatraman.R - JS Promise (Part 2 - Using Q.js, When.js and RSVP.js)</a></li>
 <li><a href="https://tech.io/playgrounds/11107/tools-for-promises-unittesting/introduction">Venkatraman.R - Tools for Promises Unit Testing</a></li>
 <li><a href="http://pouchdb.com/2015/05/18/we-have-a-problem-with-promises.html">Nolan Lawson: We have a problem with promises — Common mistakes with promises</a></li>
</ul>

<p>{{PreviousNext("Web/JavaScript/Guide/Details_of_the_Object_Model", "Web/JavaScript/Guide/Iterators_and_Generators")}}</p>
